
/**
 * CortaOrelhas.java
 *
 *
 * Created: Tue Jun 27 22:15:10 2000
 *
 * @author Roberto Speicys Cardoso
 * @author Luiz Gustavo Martins
 * @version
 */

import java.awt.*;
import java.util.*;

public class CortaOrelhas
{
    Vector aux, diag;
	long tempo;
	
	public CortaOrelhas(long t)
	{
		tempo = t;
	}

    public Vector corta(Vector pontos, Vector linhas, Graphics g) 
    {
	copia(pontos);
	int n = pontos.size();
	diag = new Vector();
	
	while(n>3)
	    {
		for(int i=0; i<n-2; i++)
		    {

			desenhaDiagonal(i, (i+2)%n, g);

			synchronized(this)
			    {
				try{
				    wait(tempo);
				}
				
				catch(InterruptedException e){
				}
			    }
			

			if(Primitivas.diagonal(i, (i+2)%n, n, aux))
			    {
				Ponto p1 = (Ponto)aux.elementAt(i);
				Ponto p2 = (Ponto)aux.elementAt((i+2)%n);
				diag.addElement(new Linha(p1, p2));
				//corta
				aux.removeElementAt((i+1)%n);
				n = aux.size();
				break;
			    }
			
			else
			    apagaDiagonal(i, (i+2)%n, g);

		    }
	    }

	return(diag);
    }
    
    public void copia(Vector p)
    {
	aux = new Vector();

	int n=p.size();
	
	for(int i=0; i<n; i++)
	    aux.addElement(p.elementAt(i));
    }

    public void desenhaDiagonal(int i, int j, Graphics g)
    {
	Ponto p1 = (Ponto)aux.elementAt(i);
	Ponto p2 = (Ponto)aux.elementAt(j);

	Color old = g.getColor();
	g.setXORMode(Color.red);
	g.drawLine(p1.x, p1.y, p2.x, p2.y);
    }

    public void apagaDiagonal(int i, int j, Graphics g)
    {
	Ponto p1 = (Ponto)aux.elementAt(i);
	Ponto p2 = (Ponto)aux.elementAt(j);

	Color old = g.getColor();
	g.drawLine(p1.x, p1.y, p2.x, p2.y);
    }
    
} // CortaOrelhas






