/**************************************************************************
// Luiz Gustavo Martins
// Roberto Speicys Cardoso
// Exerccio-Programa 01
// Curso BCC - Professor: Coelho
/**************************************************************************/

import java.applet.*; 
import java.awt.*; 
import java.awt.event.*;
import java.util.*;

public class Desenho extends Panel implements MouseListener 
{
    Dimension tam;
    Image img_aux;
    Graphics graph_aux;

    Vector pontos, linhas;
    Vector diagonais;
    boolean completo, soCores;
	Color menorCor;
	Image guarda;
    
    public Desenho()
    {
		guarda = Toolkit.getDefaultToolkit().getImage("guarda.gif");
		
		completo = false;
		soCores = false;
		pontos = new Vector();
		linhas = new Vector();
		diagonais = new Vector();
		
		setBackground(Color.white);
		setBounds(0,0,300,300);
	    
		addMouseListener(this);
    }

    public synchronized void paint(Graphics g)
    {
		// Crio um buffer para desenho
		if(tam==null)
	    {
			tam = getSize();
			img_aux = createImage(tam.width, tam.height);
			graph_aux = img_aux.getGraphics();
	    }

		desenhaPontos(graph_aux);
	    desenhaUltLinha(graph_aux);
		desenhaDiagonais(graph_aux);

		g.drawImage(img_aux, 0, 0, null);
    }

    public void desenhaPontos(Graphics g)
    {
		if(pontos.isEmpty())
		    return;
		
		for(int i=0; i<pontos.size(); i++)
		{
			Ponto ult = (Ponto)pontos.elementAt(i);
		
			ult.desenha(g);
			if(!soCores)
				g.drawString(Integer.toString(i+1), ult.getX(), ult.getY()+20);
			else
				if(ult.getColor().equals(menorCor))
				{
					g.drawImage(guarda, ult.getX(), ult.getY()-20, this);
				}
		}
		
    }
	
    
    public void desenhaUltLinha(Graphics g)
    {
		if(!linhas.isEmpty())
		{
			Linha l = (Linha)linhas.lastElement();
			g.drawLine(l.getInicio().getX(), l.getInicio().getY(), 
				   l.getFim().getX(), l.getFim().getY());
		}
    }
    
    public void desenhaDiagonais(Graphics g)
    {
	if(diagonais.size()==0)
	    return;

    	Color old = g.getColor();
	g.setColor(Color.red);
	for(int i=0; i<diagonais.size(); i++)
	    {
		Linha l = (Linha)diagonais.elementAt(i);
		g.drawLine(l.getInicio().getX(), l.getInicio().getY(), 
			   l.getFim().getX(), l.getFim().getY());
	    }
	g.setColor(old);
    }


    public void mouseClicked(MouseEvent e)
    {
		switch(e.getModifiers())
	    {
		    case MouseEvent.BUTTON1_MASK:
				if(!completo)
			    {
					addPoint(e.getPoint());
					addLine();
					repaint();
			    }
				break;

		    case MouseEvent.BUTTON3_MASK:
				completa();
				break;
	    }
		
    }

    public void completa()
    {
		Linha l = new Linha((Ponto)pontos.firstElement(), (Ponto)pontos.lastElement());
		linhas.addElement(l);
		repaint();
		completo = true;
    }
    
    public void soluciona(long tempo)
    {
		// Coloco os ponto em ordem anti-horria
		ordena();
	
		CortaOrelhas co = new CortaOrelhas(tempo);
		diagonais = co.corta(pontos, linhas, this.getGraphics());
		repaint();
		menorCor = PintaGrafo.pinta(pontos, linhas, diagonais);
		soCores=true;
		repaint();
		System.out.println("Os guardas devem ocupar as posies da cor " + menorCor.toString());
    }

	public void ordena()
	{
		if(Primitivas.areaPoly2(pontos.size(), pontos) < 0)
		{
			Vector newPts = new Vector();
			newPts.addElement(pontos.elementAt(0));

			// Inverto as posies
			for(int j=pontos.size()-1; j>0; j--)
			{				
				newPts.addElement(pontos.elementAt(j));
			}
			
			pontos = newPts;
		}
//		// Se o terceiro ponto estiver  esquerda dos dois primeiros, ento tudo bem
//		// Seno, tenho que inverter a ordem de todos os pontos
//		int prim=0, seg=1;
//		
//		// Procuro o primeiro ponto no colinear aos dois primeiros, para saber se
//		// os pontos esto em sentido anti-horrio. Pontos colineares no fornecem
//		// nenhuma informao
//		int i=2;
//		while(Primitivas.collinear((Ponto)pontos.elementAt(prim),
//									  (Ponto)pontos.elementAt(seg),
//									  (Ponto)pontos.elementAt(i)))
//			i++;
//		
//		if(!(Primitivas.left((Ponto)pontos.elementAt(prim),
//							 (Ponto)pontos.elementAt(seg),
//							 (Ponto)pontos.elementAt(i))))
//		{
//			Vector newPts = new Vector();
//			newPts.addElement(pontos.elementAt(0));
//
//			// Inverto as posies
//			for(int j=pontos.size()-1; j>0; j--)
//			{				
//				newPts.addElement(pontos.elementAt(j));
//			}
//			
//			pontos = newPts;
//		}
	}
	
    public void apaga()
    {
		linhas.removeAllElements();
		pontos.removeAllElements();
		diagonais.removeAllElements();
		completo = false;
		soCores = false;
		
		// Apago o desenho
		/*Color old = graph_aux.getColor();
		  graph_aux.setColor(Color.white);
		  graph_aux.drawRect(0, 0, this.getBounds().height, this.getBounds().width); 
		  graph_aux.setColor(old);*/
		img_aux = createImage(tam.width, tam.height);
		graph_aux = img_aux.getGraphics();
		repaint();
    }

    public void addPoint(Point p)
    {
		Ponto pt = new Ponto(p);
		
		if(podeAdicionar(pt))
			pontos.addElement(pt);
    }
	
	public boolean podeAdicionar(Ponto p)
	{
		// Se tem menos de trs pontos, pode adicionar
		if (pontos.size()<3)
			return(true);
		
		int ultimo = pontos.size()-1;
		
		for(int i=0; i<pontos.size()-2; i++)
		{
			if(Primitivas.intersect((Ponto)pontos.elementAt(i), (Ponto)pontos.elementAt(i+1),
						  			(Ponto)pontos.elementAt(ultimo), p))
				return(false);
		}	
		
		return(true);
			
		
//		// Se todos esto na mesma linha, pode adicionar
//		if (Primitivas.areaPoly2(pontos.size(), pontos)==0)
//		{
//			pontos.addElement(pt);
//			return;
//		}
//		
//		// Calculo a rea sem o ponto e com o ponto. Ambas devem ter o mesmo sinal.
//		if (Primitivas.areaPoly2(pontos.size(), pontos)<0)
//		{
//			pontos.addElement(pt);
//			
//			if (Primitivas.areaPoly2(pontos.size(), pontos)>0)
//				pontos.removeElementAt(pontos.size()-1);
//		}
//		
//		else
//		{
//			pontos.addElement(pt);
//			
//			if (Primitivas.areaPoly2(pontos.size(), pontos)<0)
//				pontos.removeElementAt(pontos.size()-1);
//		}	
    }
	
	
    public void addLine()
    {
		if(pontos.size()>1)
	    {
			Ponto ult = (Ponto)pontos.lastElement();
			Ponto pen = (Ponto)pontos.elementAt(pontos.size()-2);
			
			linhas.addElement(new Linha(ult, pen));
	    }
    }

    public void mouseEntered(MouseEvent e)
    {}

    public void mousePressed(MouseEvent e)
    {}

    public void mouseExited(MouseEvent e)
    {}

    public void mouseReleased(MouseEvent e)
    {}
    

} // Desenho



