/**************************************************************************
// Luiz Gustavo Martins
// Roberto Speicys Cardoso
// Exerccio-Programa 01
// Curso BCC - Professor: Coelho
/**************************************************************************/

import java.util.*; 
import java.awt.Color; 

public class Grafo
{
	Vector vertices;
	
	public Grafo(Vector pontos, Vector arestas, Vector diagonais)
	{
		vertices = new Vector();
	
		// Crio um vrtice para cada ponto do polgono
		for(int i=0; i<pontos.size(); i++)
		{
			Ponto p = (Ponto)pontos.elementAt(i);
			
			// Crio um vrtice do grafo para p
			Vertice v = new Vertice(p);
			vertices.addElement(v);
			
			// Procuro todos os vizinhos de p
			for(int j=0; j<arestas.size(); j++)
			{
				Linha l = (Linha)arestas.elementAt(j);
				
				if (l.getInicio().equals(p))
				{
					v.addVizinho(l.getFim());
				}
				
				else
				{
					if (l.getFim().equals(p))
					{
						v.addVizinho(l.getInicio());
					}
				}
			}
			
			for(int j=0; j<diagonais.size(); j++)
			{
				Linha l = (Linha)diagonais.elementAt(j);
				
				if (l.getInicio().equals(p))
				{
					v.addVizinho(l.getFim());
				}
				
				else
				{
					if (l.getFim().equals(p))
					{
						v.addVizinho(l.getInicio());
					}
				}
			}
		}
	}
	
	public String toString()
	{
		String graf_str = new String();
		
		for(int i=0; i<vertices.size(); i++)
		{
			Vertice v = (Vertice)vertices.elementAt(i);
			graf_str = graf_str.concat("O vrtice " + (i+1) + " tem " + v.getVizinhos().size() + " vizinhos\n");
		}
		
		return(graf_str);
	}
	
	public Vertice firstElement()
	{ return((Vertice)vertices.firstElement());}
	
	public Ponto encontraOposto(Ponto a, Ponto b)
	{
		for(int i=0; i<vertices.size(); i++)
		{
			Vertice possivelOposto = (Vertice)vertices.elementAt(i);
			
			// Verifico se o ponto ainda no foi pintadp
			if (possivelOposto.getPonto().getColor()==Color.black)
			{
				if(possivelOposto.ehVizinho(a) && possivelOposto.ehVizinho(b))
					return(possivelOposto.getPonto());
			}	
		}
		
		return(null);
	}	
}
