/**************************************************************************
// Luiz Gustavo Martins
// Roberto Speicys Cardoso
// Exerccio-Programa 01
// Curso BCC - Professor: Coelho
/**************************************************************************/

import java.awt.*; 
import java.awt.event.*;
import java.util.*;

public final class PintaGrafo 
{
	static Grafo grafo;
	static Vector bases;
	
	
    public static Color pinta(Vector vertices, Vector arestas, Vector diagonais)
    {
		// Pr-processamento. Transforma a estrutura de pontos e arestas em um
		// grafo. No grafo  guardado um vetor de vrtices, e cada vrtice guarda
		// uma lista com seus vizinhos.
		grafo = new Grafo(vertices, arestas, diagonais);
		bases = new Vector();
		
		System.out.println(grafo.toString());
		
		// Escolho um primeiro ponto qualquer
		Ponto a = grafo.firstElement().getPonto();
		
		// Como o vetor de vrtices do grafo est na mesma ordem que o vetor de pontos
		// do polgono, pego o primeiro vrtice do grafo e procuro algum vizinho para pintar
		Ponto b = grafo.firstElement().firstVizinho();
		
		// Pinto os dois primeiros vizinhos de qualquer cor
		a.setColor(Color.red);
		b.setColor(Color.blue);
		int verm=1, amar=0, azul=1;
		
		// Adiciono a linha encontrada ao vetor de bases de tringulos a serem analisados
		Linha ab = new Linha(a, b);
		bases.addElement(ab);
		
		Linha baseNova1, baseNova2;
		
		
		// Analiso cada aresta que j possui seus extremos pintados
		while (!bases.isEmpty())
		{
			Linha analisada = (Linha)bases.firstElement();
			a = analisada.getInicio();
			b = analisada.getFim();
			Ponto oposto = grafo.encontraOposto(a,b);
			
			if (oposto!=null)
			{
				if (!a.getColor().equals(Color.yellow) && !b.getColor().equals(Color.yellow))
				{
					oposto.setColor(Color.yellow);
					amar++;
				}
				else
				{  
					if (!a.getColor().equals(Color.blue) && !b.getColor().equals(Color.blue))
					{
						oposto.setColor(Color.blue);
						azul++;
					}
					else 
					{
						if (!a.getColor().equals(Color.red) && !b.getColor().equals(Color.red))
						{
							oposto.setColor(Color.red);
							verm++;
						}
					}
				}
				
				baseNova1 = new Linha(a, oposto);
				bases.addElement(baseNova1);
				baseNova2 = new Linha(b, oposto);
				bases.addElement(baseNova2);
			}
			
			// Apago a linha analisada
			bases.removeElementAt(0);
		}
		
		// Devolvo a cor menos usada
		if(verm<=amar && verm<=azul)
			return(Color.red);
		if(azul<=amar && azul<=verm)
			return(Color.blue);	
		
		return(Color.yellow);	
    }
	
}
