
/**
 * Primitivas.java
 *
 *
 * Created: Tue Jun 27 21:54:43 2000
 *
 * @author Roberto Speicys Cardoso
 * @version
 */

import java.awt.*; 
import java.util.*; 

public final class Primitivas
{
    
    public Primitivas() 
    {
	
    }

    public static int area2(Ponto aT, Ponto bT, Ponto cT)
    {
		Ponto a, b, c;
		a = tela2cart(aT);
		b = tela2cart(bT);
		c = tela2cart(cT);
		
		return(a.x * b.y - a.y * b.x + a.y * c.x - a.x * c.y + b.x * c.y - c.x * b.y);
    }
	
	public static int areaPoly2(int n, Vector p)
	{
		int i, sum=0;
		
		for(i=1; i<n-1; i++)
			sum+=area2((Ponto)p.elementAt(0), (Ponto)p.elementAt(i), (Ponto)p.elementAt(i+1));
			
		return(sum);	
	}
	

    public static boolean left(Ponto a, Ponto b, Ponto c)
    {
	return(area2(a, b, c) > 0);
    }

    public static boolean leftOn(Ponto a, Ponto b, Ponto c)
    {
	return(area2(a, b, c) >= 0);
    }

    public static boolean collinear(Ponto a, Ponto b, Ponto c)
    {
	return(area2(a, b, c)==0);
    }

    public static boolean intersectProp(Ponto a, Ponto b, Ponto c, Ponto d)
    {
	if(collinear(a, b, c) || collinear(a, b, d) ||
	   collinear(c, d, a) || collinear(c, d, b))
	    return(false);
	
	return(xor(left(a, b, c), left(a, b, d)) && xor(left(c, d, a), left(c, d, b)));
    }
    
    public static boolean xor(boolean a, boolean b)
    {
	return(!a==b);
    }
    
    public static boolean between(Ponto aT, Ponto bT, Ponto cT)
    {
	if(!collinear(aT, bT, cT))
	    return(false);

	Ponto a, b, c;
	a = tela2cart(aT);
	b = tela2cart(bT);
	c = tela2cart(cT);
	
	if(a.x!=b.x)
	    return((a.x<=c.x && c.x<=b.x) || (a.x>=c.x && c.x>=b.x));
	else
	    return((a.y<=c.y && c.y<=b.y) || (a.y>=c.y && c.y>=b.y));
    }
    
    public static boolean intersect(Ponto a, Ponto b, Ponto c, Ponto d)
    {
	if(intersectProp(a, b, c, d))
	    return(true);
	else
	    if(between(a, b, c) || between(a, b, d) || between(c, d, a) || between(c, d, b))
		return(true);
	    else
		return(false);
    }
		
    public static boolean diagonalie(int i, int j, int n, Vector p)
    {
		int k, k1;
		
		for(k=0; k<n; k++)
	    {
			k1 = (k+1)%n;
			if(!((k==i) || (k1==i) || (k==j) || (k1==j)))
			    if (intersect((Ponto)p.elementAt(i), (Ponto)p.elementAt(j), 
					 (Ponto)p.elementAt(k), (Ponto)p.elementAt(k1)))
					return(false);
	    }

		return(true);
    }

    public static boolean inCone(int i, int j, int n, Vector p)
    {
	int i1, in1;
	i1 = (i+1)%n;
	in1 = (i+n-1)%n;
	
	Ponto aux = (Ponto)p.elementAt(in1);
	aux = (Ponto)p.elementAt(i);
	aux = (Ponto)p.elementAt(i1);
	
	if(leftOn((Ponto)p.elementAt(in1), (Ponto)p.elementAt(i), (Ponto)p.elementAt(i1)))
	    {
		return(left((Ponto)p.elementAt(i), (Ponto)p.elementAt(j), (Ponto)p.elementAt(in1)) &&
		       left((Ponto)p.elementAt(j), (Ponto)p.elementAt(i), (Ponto)p.elementAt(i1)));
	    }
	else
	    {
		return(!(leftOn((Ponto)p.elementAt(i), (Ponto)p.elementAt(j), (Ponto)p.elementAt(i1)) &&
			 leftOn((Ponto)p.elementAt(j), (Ponto)p.elementAt(i), (Ponto)p.elementAt(in1))));
	    }
    }

    public static boolean diagonal(int i, int j, int n, Vector p)
    {
		return(inCone(i, j, n, p) && diagonalie(i, j, n, p));
    }
	
    public static Ponto tela2cart(Ponto p)
    { return(new Ponto(p.x, (p.y-300)*-1)); }

    public static Ponto cart2tela(Ponto p)
    { return(new Ponto(p.x, (p.y-300)*-1)); }

    
} // Primitivas







