/**************************************************************************
// Marcel H. Yoshizako
// Marcelo Eiji Morioka
// Roberto Speicys Cardoso
// Exerccio-Programa 03
// Curso BCC - Professor: Dilma
// Computador: Pentium 133 Mhz
// Compilador: JDK 1.1.3
/**************************************************************************
/*-------------------------------------------------------------------------
	Janela principal do EP03. Contm toda interface com o usurio que
permite a seleo dos parmetros da simulao
-------------------------------------------------------------------------*/

import java.awt.*; 
import java.awt.event.*;
import java.io.*;

class Simulacao extends Frame implements ActionListener
{
    Panel	Toolbar;
    Button	Start, Stop, EmergA, EmergB, Limusine, MaisK, MenosK;
    Label	Tragedias, ConstK;
    
    Dimension tam, tam2;
    Image img_aux, img_aux2;
    Graphics graph_aux, graph_aux2;
    
    Veiculo frota[];
    PonteNova ponte;
    FilaEmerg emergencias;
    
    static public final int ILHA_A = 0;
    static public final int ILHA_B = 1;
    
    
    // Contador de tragdias e do tempo da ponte
    int tragedia, const_k;
    int ambLivres;
    boolean podeDesenhar = false;

    int nFuscaA, nFuscaB, nFerrariA, nFerrariB, nAmbulancias;
    int nVeiculos;
    long k;
    
    MediaTracker tracker;
    Image cenario;
    Graphics graph_cenario;

    
    Object limusineEspera;
        
    
    public Simulacao()
    {
	setTitle("EP de Geocomp");
	setBounds(0, 0, 800, 600);
	
	// Crio a barra de ferramentas
	Start  = new Button("Start");
	Stop   = new Button("Stop");
	EmergA = new Button("Emergncia A");
	EmergB = new Button("Emergncia B");
	Limusine = new Button("Limusine");
	MaisK = new Button("+");
	MenosK = new Button("-");

	Tragedias = new Label("0");
	ConstK = new Label("");
	
	Tragedias.setEnabled(true);
	ConstK.setEnabled(true);
	
	setBackground(Color.lightGray);
		
	Toolbar = new Panel();
	Toolbar.setLayout(new FlowLayout(FlowLayout.LEFT));
	Toolbar.setBackground(Color.lightGray);
	Toolbar.add(Start);
	Toolbar.add(new Label());
	Toolbar.add(Stop);
	Toolbar.add(new Label());
	Toolbar.add(EmergA);
	Toolbar.add(new Label());
	Toolbar.add(EmergB);
	Toolbar.add(new Label());
	Toolbar.add(Limusine);
	Toolbar.add(new Label());

	Toolbar.add(new Label("K (s)"));
	Toolbar.add(ConstK);
	Toolbar.add(MaisK);
	Toolbar.add(MenosK);
	Toolbar.add(new Label());
	Toolbar.add(new Label("Tragdias"));
	Toolbar.add(Tragedias);
	
	add(Toolbar, "North");
	
	// Adiciono os action listeners dos botes
	Start.addActionListener(this);
	Stop.addActionListener(this);
	EmergA.addActionListener(this);
	EmergB.addActionListener(this);
	Limusine.addActionListener(this);
	MaisK.addActionListener(this);
	MenosK.addActionListener(this);

	// Carrego a imagem de fundo
	tracker = new MediaTracker(this);
	cenario = Toolkit.getDefaultToolkit().getImage("ponte.gif");
	tracker.addImage(cenario, 0);
	try
	    {
		tracker.waitForAll();
	    }
	catch(InterruptedException e)
	    {
		System.out.println(e);
	    }
	k = 10000;
	limusineEspera = new Object();

	leArquivo();
	inicializaVeiculos();
	
	ConstK.setText(Long.toString(k/1000));
	
	ambLivres = nAmbulancias;
    }

    public void start()
    {
	System.out.println("Vai iniciar a thread");
	podeDesenhar = true;	
	repaint();

	for(int i=0; i<nVeiculos; i++)
	    {
		frota[i].start();
	    }

	ponte.setK(k);
	ponte.start();
    }
	
    public void repaint()
    {
	paint(this.getGraphics());
    }

    public void repaint(Veiculo v)
    {	
	Graphics g = this.getGraphics();

	// Crio um buffer para desenho
	/*if(tam2==null)
	  {
	  tam2 = getSize();
	  img_aux2 = createImage(tam2.width, tam2.height);
	  graph_aux2 = img_aux2.getGraphics();
	  }*/
	    
	// Desenho o carro
	v.apaga(graph_aux, this);
	v.desenha(graph_aux, this);
	
	g.drawImage(img_aux, 0, 20, null);	
    }
    
    public void repaint(Cancela c)
    {	
	Graphics g = this.getGraphics();

	// Desenho a cancela
	c.desenha(graph_aux, this);
	
	g.drawImage(img_aux, 0, 20, null);	
    }

    public void repaint(Guardinha guarda)
    {	
	Graphics g = this.getGraphics();

	// Desenho o guardinha
	guarda.desenha(graph_aux, this);
	
	g.drawImage(img_aux, 0, 20, null);	
    }
    
    
    public synchronized void paint(Graphics g)
    {	
	// Crio um buffer para desenho
	if(tam==null)
	    {
		tam = getSize();
		img_aux = createImage(tam.width, tam.height);
		graph_aux = img_aux.getGraphics();
		graph_aux.drawImage(cenario, 0, 20, null);
	    }
	    
	// Desenho os carros
	if(podeDesenhar)
	    {
		//while(!graph_aux.drawImage(cenario, 0, 20, null));

		for(int i = 0; i<nVeiculos; i++)
		    {
			while(!frota[i].apaga(graph_aux, this))
			    System.out.println("Apagando...");
			while(!frota[i].desenha(graph_aux, this))
			    System.out.println("Desenhando...");
		    }
		
		ponte.iniCancela(graph_aux, this);
		ponte.iniGuardinha(graph_aux, this);
		g.drawImage(img_aux, 0, 20, null);
	    }
    }
    
    	
    public void actionPerformed(ActionEvent e) 
    {
	String botao = e.getActionCommand();
	
	if(botao.compareTo("Start")==0)
	    {
		start();
		return;
	    }
	if(botao.compareTo("Emergncia A")==0)
	    {
		synchronized(this)
		    {
			if(ambLivres>0)
			    {
				emergencias.insere(ILHA_A);
				ambLivres--;
				notify();
			    }
			else
			    aconteceuTragedia();
		    }
		return;
	    }
	if(botao.compareTo("Emergncia B")==0)
	    {
		synchronized(this)
		    {
			if(ambLivres>0)
			    {
				emergencias.insere(ILHA_B);
				ambLivres--;
				notify();
			    }
			else
			    aconteceuTragedia();
		    }
		return;
	    }
	if(botao.compareTo("Limusine")==0)
	    {
		synchronized(limusineEspera)
		    {
			limusineEspera.notify();
		    }
		return;
	    }

	if(botao.compareTo("+")==0)
	    {
		k+=1000;
		ConstK.setText(Long.toString(k/1000));
		ponte.setK(k);
	    }
	
	if(botao.compareTo("-")==0)
	    {
		if(k>1000)
		    {
			k-=1000;
			ConstK.setText(Long.toString(k/1000));
			ponte.setK(k);
		    }
	    }
	if(botao.compareTo("Stop")==0)
	    {
		for(int i=0; i<nVeiculos; i++)
		    {
			frota[i].pare();
			synchronized(frota[i])
			    {
				frota[i].notify();
			    }
		    }
		synchronized(this)
		    {
			notifyAll();
		    }

		ponte.pare();

		inicializaVeiculos();
	    }
    }
    

    public synchronized boolean mudaDeIlha(Veiculo v)
    { 
	if(ponte.mudaDeIlha(v))
	    return(true);
	else
	    return(false);
    }
    
    public synchronized void aconteceuTragedia()
    { 
	tragedia++;
	Tragedias.setText(Integer.toString(tragedia));
    }
    
    public synchronized boolean possoAndar(Veiculo v)
    { 
	if(ponte.possoAndar(v))
	    {
		return(true);
	    }
	else
	    return(false);
    }

    public synchronized int getEmergencia()
    {
	int lugar = emergencias.primeiro();
	emergencias.remove();
	return(lugar);
    }
    
    public synchronized void ambulanciaLivre()
    { ambLivres++; }

    
    public boolean souPrimeiro(Veiculo v)
    { return(ponte.souPrimeiro(v)); }

    public boolean leArquivo()
    {
	try
	    {
		// Crio o objeto associado ao arquivo
		File arq = new File("dados.in");
		// Crio o leitor do arquivo
		FileReader arq_in = new FileReader(arq);
		// Crio uma entrada de arquivo bufferizada, para poder ler linhas
		BufferedReader in = new BufferedReader(arq_in);
		// Leio o arquivo em tokens
		StreamTokenizer tokens = new StreamTokenizer(arq_in);
		
		int nParam = 0;
				
		while(tokens.nextToken() != StreamTokenizer.TT_EOF)
		    {
			if(tokens.ttype == StreamTokenizer.TT_NUMBER)
			    {
				switch(nParam)
				    {
				    case 0:
					nFuscaA = (int)tokens.nval;
					break;
					
				    case 1:
					nFerrariA = (int)tokens.nval;
					break;
					
				    case 2:
					nFuscaB = (int)tokens.nval;
					break;

				    case 3:
					nFerrariB = (int)tokens.nval;
					break;
					
				    case 4:
					nAmbulancias = (int)tokens.nval;
					break;
				    }
				nParam++;
			    }
		    }
	    }
	catch(NullPointerException e)
	    {
		return(false);
	    }
	catch(FileNotFoundException ex)
	    {
		return(false);
	    }
	catch(IOException exc)
	    {
		return(false);
	    }
	
	System.out.println("Fuscas em A " + nFuscaA + " Ferraris em A " + nFerrariA + " Fuscas em B " + nFuscaB + " Ferraris em B " + nFerrariB + " Ambulancias " + nAmbulancias);
	
	return(true);
    }

    public void inicializaVeiculos()
    {
	emergencias = new FilaEmerg();
	ponte = new PonteNova(this, k, cenario);
	
	nVeiculos = nFuscaA + nFuscaB + nFerrariA + nFerrariB + nAmbulancias + 1; // 1 = limusine

	frota = new Veiculo[nVeiculos];

	frota[nVeiculos-1] = new Limusine(this, 45,  200, nVeiculos-1, cenario);

	for(int i=0; i<nVeiculos-1; i++)
	    {
		if(i<nFuscaA)
		    {
			frota[i] = new Fusca(this, ILHA_A, (45+((i%15)*15)), (45+((i/15)*20)), i, cenario);
			continue;
		    }
		if(i<nFuscaA+nFerrariA)
		    {
			frota[i] = new Ferrari(this, ILHA_A, (45+((i%15)*15)), (45+((i/15)*20)), i, cenario);
			continue;
		    }
		if(i<nFuscaA+nFerrariA+nFuscaB)
		    {
			frota[i] = new Fusca(this, ILHA_B, (45+((i%15)*15)), (550+((i/15)*20)), i, cenario);
			continue;
		    }
		if(i<nFuscaA+nFerrariA+nFuscaB+nFerrariB)
		    {
			frota[i] = new Ferrari(this, ILHA_B, (45+((i%15)*15)), (550+((i/15)*20)), i, cenario);
			continue;
		    }
		if(i<nFuscaA+nFerrariA+nFuscaB+nFerrariB+nAmbulancias)
		    {
			frota[i] = new Ambulancia(this, (45 + ((i%15)*15)),  (45 + ((i/15)*20)), i, cenario);
			continue;
		    }
	    }
    }

     /**
       * Get the value of limusineEspera.
       * @return Value of limusineEspera.
       */
    public Object getLimusineEspera() {return limusineEspera;}
    
    /**
       * Set the value of limusineEspera.
       * @param v  Value to assign to limusineEspera.
       */
    public void setLimusineEspera(Object  v) {this.limusineEspera = v;}
}










